#ifndef bluetoothio_h_
#define bluetoothio_h_


#if BLUESERIAL_IN_SOFTWARE
// Anbindung des Bluetooth-Moduls (HC-05) ber Software-Serial() mit Sende-Puffer:
//
#include "BufferedSoftwareSerial.h"
extern BufferedSoftwareSerial blueSerial;
#else
#define blueSerial  Serial
#endif

#define blueBaud    9600	// Baudrate zur Anbindung des Bluetooth-Moduls


inline void bluePrint(int i)		  { blueSerial.print(i); }
inline void bluePrintln(int i)		  { blueSerial.println(i); }
inline void bluePrintln()		  { blueSerial.println(); }
inline void bluePrintHex(uint8_t x)	  { blueSerial.printHex(x); }
inline void bluePrintHex(uint16_t x)	  { blueSerial.printHex(x); }
       void bluePrint_P(PGM_P s);
       void bluePrintln_P(PGM_P s);
       void bluePrintDecimals(int val, int n);
       void bluePrintTdegC(int Tx10);
       void bluePrintTdegCsign(int Tx10);

#if BLUESERIAL_IN_SOFTWARE
inline unsigned blueGetFreeCount()           {return blueSerial.GetFreeCount();}
inline unsigned blueGetHalfSize()            {return blueSerial.GetHalfSize();}
#else
inline unsigned blueGetFreeCount()           {return MAXINT;}
inline unsigned blueGetHalfSize()            {return MAXINT/2;}
#endif


#endif
