#ifndef FlashUpdate_h_
#define FlashUpdate_h_

#if defined(SPIFLASH_CS)
// SPIMemory Library required! (https://github.com/Marzogh/SPIMemory)

#include<SPIFlash.h>	  // braucht ca. 330 Bytes RAM!!!! (SparkFun_SPI_SerialFlash ist ähnlich)
			  //(https://github.com/LowPowerLab/SPIFlash/tree/master evtl schlanker?)

class BootFlash : public SPIFlash {
  public:
	    BootFlash(uint8_t cs = CS) : SPIFlash(cs) {uploadState = 0;}
    int8_t  Add(int8_t c);
    bool    Reset(bool eraseFlash = true);
    bool    HasValidUpload() const    {return uploadState > 0;}
    bool    WriteFirstBytes();

  protected:
    //uint8_t GetDigitVal(uint8_t pos) const    {return (lineBuffer[pos] - '0');}
    //uint8_t GetByteVal(uint8_t pos) const     {return GetDigitVal(pos) + (GetDigitVal(pos) << 4);}

    uint8_t GetByteCount() const      {return lineBuffer[0];}
    uint8_t GetRecordType() const     {return lineBuffer[3];}
    uint8_t* GetData()	  	      {return &lineBuffer[4];}
    uint16_t GetAddress() const	      {return (lineBuffer[1] << 8) | lineBuffer[2];}

  protected:
    uint8_t lineBuffer[1+2+1+32+1]; // Byte count + Address + Record type + Data + Checksum
    int8_t  digitCnt;
    uint8_t limit;
    uint8_t byteCount;
    uint8_t firstBytes[2];
    uint8_t checksum;
    int8_t  uploadState;
};


inline
bool BootFlash::WriteFirstBytes()
{
  if (writeByteArray(0, firstBytes, 2, true)) {
    uploadState = 2;      // zeigt an, dass Upload vollständig ist
    return true;
  }
  return false;
}


extern BootFlash bootFlash;

#endif // SPIFLASH_CS

#endif
